﻿using System;
using System.Diagnostics;
using System.Windows.Forms;

namespace RCM {
    [DisplayName("Browse via SMB")]
    public class SMBAction : IAction {
        private RDP _rdp;

        public SMBAction(RDP rdp) {
            _rdp = rdp;
        }

        public void Run() {
            string[] host = _rdp.Host.Split(":".ToCharArray());

            if (Environment.OSVersion.Platform == PlatformID.Unix) {
                MessageBox.Show("This feature is not yet implemented", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                // TODO: Implement
            } else {
                Process netUse = Process.Start("net", string.Format("use \\\\{0} \"/USER:{1}\" \"{2}\"", host[0], _rdp.Username, _rdp.Password));
                netUse.WaitForExit();
                if (netUse.ExitCode == 0) {
                    Process.Start("explorer.exe", string.Format("\\\\{0}", host[0]));
                } else {
                    MessageBox.Show("Unable to open the SMB share path", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
