﻿using System;
using System.Windows.Forms;

namespace RCM {
    [DisplayName("SSH")]
    [Serializable]
    public class SSHConfig : IConfigSection {
        public string[] SSHKeys { get; set; }
        public string PuttyPath { get; set; }
        public string PageantPath { get; set; }
        public string WinSCPPath { get; set; }
        public string LinuxSSHCommand { get; set; }
        [NonSerialized]
        private SSHConfigControl _control;

        public UserControl GetControl() {
            if (_control == null || _control.IsDisposed) {
                _control = new SSHConfigControl(this);
            }
            return _control;
        }

        public void UpdateFromControl() {
            SSHKeys = _control.SSHKeys;
            PuttyPath = _control.textBoxPutty.Text;
            PageantPath = _control.textBoxPageant.Text;
            WinSCPPath = _control.textBoxWinSCP.Text;
            LinuxSSHCommand = _control.textBoxLinuxSSHCommand.Text;
        }
    }
}
