﻿using System;
using System.Windows.Forms;

namespace RCM {
    [Serializable]
    public class WebSite : IRecord {
        public Guid Id { get; set; }
        public string Title { get; set; }
        public Guid GroupId { get; set; }

        public string URL { get; set; }
        public string Username { get; set; }
        public string Password { get; set; }
        [NonSerialized]
        private WebSiteControl _control;
        [NonSerialized]
        private IAction[] _actions;

        public IAction[] GetActions() {
            if (_actions == null) {
                _actions = new IAction[] { new BrowserAction(this) };
            }
            return _actions;
        }

        public UserControl GetControl() {
            if (_control == null || _control.IsDisposed) {
                _control = new WebSiteControl(this);
            }
            return _control;
        }

        public void UpdateFromControl() {
            URL = _control.textBoxURL.Text;
            Username = _control.textBoxUsername.Text;
            Password = _control.textBoxPassword.Text;
        }
    }
}
